Index: cmake/FindCOIN.cmake
===================================================================
--- cmake/FindCOIN.cmake	(revision 1180)
+++ cmake/FindCOIN.cmake	(revision 1064)
@@ -66,10 +66,4 @@
 )
 
-FIND_LIBRARY(COIN_PTHREADS_LIBRARY
-  NAMES pthreads libpthreads
-  HINTS ${COIN_ROOT_DIR}/lib/coin
-  HINTS ${COIN_ROOT_DIR}/lib
-)
-
 INCLUDE(FindPackageHandleStandardArgs)
 FIND_PACKAGE_HANDLE_STANDARD_ARGS(COIN DEFAULT_MSG
@@ -89,5 +83,5 @@
 IF(COIN_FOUND)
   SET(COIN_INCLUDE_DIRS ${COIN_INCLUDE_DIR})
-  SET(COIN_CLP_LIBRARIES "${COIN_CLP_LIBRARY};${COIN_COIN_UTILS_LIBRARY}")
+  SET(COIN_CLP_LIBRARIES "${COIN_CLP_LIBRARY};${COIN_COIN_UTILS_LIBRARY};${COIN_ZLIB_LIBRARY};${COIN_BZ2_LIBRARY}")
   IF(COIN_ZLIB_LIBRARY)
     SET(COIN_CLP_LIBRARIES "${COIN_CLP_LIBRARIES};${COIN_ZLIB_LIBRARY}")
@@ -96,8 +90,5 @@
     SET(COIN_CLP_LIBRARIES "${COIN_CLP_LIBRARIES};${COIN_BZ2_LIBRARY}")
   ENDIF(COIN_BZ2_LIBRARY)
-   IF(COIN_PTHREADS_LIBRARY)
-    SET(COIN_CLP_LIBRARIES "${COIN_CLP_LIBRARIES};${COIN_PTHREADS_LIBRARY}")
-  ENDIF(COIN_PTHREADS_LIBRARY)
-  SET(COIN_CBC_LIBRARIES "${COIN_CBC_LIBRARY};${COIN_CBC_SOLVER_LIBRARY};${COIN_CGL_LIBRARY};${COIN_OSI_LIBRARY};${COIN_OSI_CBC_LIBRARY};${COIN_OSI_CLP_LIBRARY};${COIN_CLP_LIBRARIES}")
+  SET(COIN_CBC_LIBRARIES "${COIN_CBC_LIBRARY};${COIN_CBC_SOLVER_LIBRARY};${COIN_CGL_LIBRARY};${COIN_OSI_LIBRARY};${COIN_OSI_CBC_LIBRARY};${COIN_OSI_CLP_LIBRARY};${COIN_ZLIB_LIBRARY};${COIN_BZ2_LIBRARY};${COIN_CLP_LIBRARIES}")
   SET(COIN_LIBRARIES ${COIN_CBC_LIBRARIES})
 ENDIF(COIN_FOUND)
Index: lemon/adaptors.h
===================================================================
--- lemon/adaptors.h	(revision 1184)
+++ lemon/adaptors.h	(revision 1092)
@@ -3447,8 +3447,8 @@
     /// This map adaptor class adapts two node maps of the original digraph
     /// to get a node map of the split digraph.
-    /// Its value type is inherited from the first node map type (\c In).
-    /// \tparam In The type of the node map for the in-nodes.
-    /// \tparam Out The type of the node map for the out-nodes.
-    template <typename In, typename Out>
+    /// Its value type is inherited from the first node map type (\c IN).
+    /// \tparam IN The type of the node map for the in-nodes.
+    /// \tparam OUT The type of the node map for the out-nodes.
+    template <typename IN, typename OUT>
     class CombinedNodeMap {
     public:
@@ -3457,14 +3457,14 @@
       typedef Node Key;
       /// The value type of the map
-      typedef typename In::Value Value;
-
-      typedef typename MapTraits<In>::ReferenceMapTag ReferenceMapTag;
-      typedef typename MapTraits<In>::ReturnValue ReturnValue;
-      typedef typename MapTraits<In>::ConstReturnValue ConstReturnValue;
-      typedef typename MapTraits<In>::ReturnValue Reference;
-      typedef typename MapTraits<In>::ConstReturnValue ConstReference;
+      typedef typename IN::Value Value;
+
+      typedef typename MapTraits<IN>::ReferenceMapTag ReferenceMapTag;
+      typedef typename MapTraits<IN>::ReturnValue ReturnValue;
+      typedef typename MapTraits<IN>::ConstReturnValue ConstReturnValue;
+      typedef typename MapTraits<IN>::ReturnValue Reference;
+      typedef typename MapTraits<IN>::ConstReturnValue ConstReference;
 
       /// Constructor
-      CombinedNodeMap(In& in_map, Out& out_map)
+      CombinedNodeMap(IN& in_map, OUT& out_map)
         : _in_map(in_map), _out_map(out_map) {}
 
@@ -3498,6 +3498,6 @@
     private:
 
-      In& _in_map;
-      Out& _out_map;
+      IN& _in_map;
+      OUT& _out_map;
 
     };
@@ -3507,26 +3507,26 @@
     ///
     /// This function just returns a combined node map.
-    template <typename In, typename Out>
-    static CombinedNodeMap<In, Out>
-    combinedNodeMap(In& in_map, Out& out_map) {
-      return CombinedNodeMap<In, Out>(in_map, out_map);
-    }
-
-    template <typename In, typename Out>
-    static CombinedNodeMap<const In, Out>
-    combinedNodeMap(const In& in_map, Out& out_map) {
-      return CombinedNodeMap<const In, Out>(in_map, out_map);
-    }
-
-    template <typename In, typename Out>
-    static CombinedNodeMap<In, const Out>
-    combinedNodeMap(In& in_map, const Out& out_map) {
-      return CombinedNodeMap<In, const Out>(in_map, out_map);
-    }
-
-    template <typename In, typename Out>
-    static CombinedNodeMap<const In, const Out>
-    combinedNodeMap(const In& in_map, const Out& out_map) {
-      return CombinedNodeMap<const In, const Out>(in_map, out_map);
+    template <typename IN, typename OUT>
+    static CombinedNodeMap<IN, OUT>
+    combinedNodeMap(IN& in_map, OUT& out_map) {
+      return CombinedNodeMap<IN, OUT>(in_map, out_map);
+    }
+
+    template <typename IN, typename OUT>
+    static CombinedNodeMap<const IN, OUT>
+    combinedNodeMap(const IN& in_map, OUT& out_map) {
+      return CombinedNodeMap<const IN, OUT>(in_map, out_map);
+    }
+
+    template <typename IN, typename OUT>
+    static CombinedNodeMap<IN, const OUT>
+    combinedNodeMap(IN& in_map, const OUT& out_map) {
+      return CombinedNodeMap<IN, const OUT>(in_map, out_map);
+    }
+
+    template <typename IN, typename OUT>
+    static CombinedNodeMap<const IN, const OUT>
+    combinedNodeMap(const IN& in_map, const OUT& out_map) {
+      return CombinedNodeMap<const IN, const OUT>(in_map, out_map);
     }
 
Index: lemon/arg_parser.cc
===================================================================
--- lemon/arg_parser.cc	(revision 1179)
+++ lemon/arg_parser.cc	(revision 877)
@@ -222,7 +222,7 @@
   {
     Opts::iterator o = _opts.find(opt);
+    Opts::iterator s = _opts.find(syn);
     LEMON_ASSERT(o!=_opts.end(), "Unknown option: '"+opt+"'");
-    LEMON_ASSERT(_opts.find(syn)==_opts.end(),
-                 "Option already used: '"+syn+"'");
+    LEMON_ASSERT(s==_opts.end(), "Option already used: '"+syn+"'");
     ParData p;
     p.help=opt;
Index: lemon/bits/vf2_internals.h
===================================================================
--- lemon/bits/vf2_internals.h	(revision 1186)
+++ lemon/bits/vf2_internals.h	(revision 1186)
@@ -0,0 +1,48 @@
+/* -*- mode: C++; indent-tabs-mode: nil; -*-
+ *
+ * This file is a part of LEMON, a generic C++ optimization library.
+ *
+ * Copyright (C) 2015-2017
+ * EMAXA Kutato-fejleszto Kft. (EMAXA Research Ltd.)
+ *
+ * Permission to use, modify and distribute this software is granted
+ * provided that this copyright notice appears in all copies. For
+ * precise terms see the accompanying LICENSE file.
+ *
+ * This software is provided "AS IS" with no warranty of any kind,
+ * express or implied, and with no claim as to its suitability for any
+ * purpose.
+ *
+ */
+
+#ifndef VF2_INTERNALS_H
+#define VF2_INTERNALS_H
+
+
+///\ingroup graph_properties
+///\file
+///\brief Mapping types for graph matching algorithms.
+
+namespace lemon {
+  ///\ingroup graph_isomorphism
+  ///The \ref Vf2 "VF2" algorithm is capable of finding different kind of
+  ///embeddings, this enum specifies its type.
+  ///
+  ///See \ref graph_isomorphism for a more detailed description.
+  enum MappingType {
+    /// Subgraph isomorphism
+    SUBGRAPH = 0,
+    /// Induced subgraph isomorphism
+    INDUCED = 1,
+    /// Graph isomorphism
+
+    /// If the two graph has the same number of nodes, than it is
+    /// equivalent to \ref INDUCED, and if they also have the same
+    /// number of edges, then it is also equivalent to \ref SUBGRAPH.
+    ///
+    /// However, using this setting is faster than the other two
+    /// options.
+    ISOMORPH = 2
+  };
+}
+#endif
Index: lemon/lgf_reader.h
===================================================================
--- lemon/lgf_reader.h	(revision 1161)
+++ lemon/lgf_reader.h	(revision 1150)
@@ -452,11 +452,11 @@
   ///
   ///\code
-  /// DigraphReader<DGR>(digraph, std::cin)
-  ///   .nodeMap("coordinates", coord_map)
-  ///   .arcMap("capacity", cap_map)
-  ///   .node("source", src)
-  ///   .node("target", trg)
-  ///   .attribute("caption", caption)
-  ///   .run();
+  /// DigraphReader<DGR>(digraph, std::cin).
+  ///   nodeMap("coordinates", coord_map).
+  ///   arcMap("capacity", cap_map).
+  ///   node("source", src).
+  ///   node("target", trg).
+  ///   attribute("caption", caption).
+  ///   run();
   ///\endcode
   ///
@@ -1247,9 +1247,9 @@
   ///ListDigraph::ArcMap<int> cap(digraph);
   ///ListDigraph::Node src, trg;
-  ///digraphReader(digraph, std::cin)
-  ///  .arcMap("capacity", cap)
-  ///  .node("source", src)
-  ///  .node("target", trg)
-  ///  .run();
+  ///digraphReader(digraph, std::cin).
+  ///  arcMap("capacity", cap).
+  ///  node("source", src).
+  ///  node("target", trg).
+  ///  run();
   ///\endcode
   ///
@@ -2124,7 +2124,7 @@
   ///ListGraph graph;
   ///ListGraph::EdgeMap<int> weight(graph);
-  ///graphReader(graph, std::cin)
-  ///  .edgeMap("weight", weight)
-  ///  .run();
+  ///graphReader(graph, std::cin).
+  ///  edgeMap("weight", weight).
+  ///  run();
   ///\endcode
   ///
@@ -3192,7 +3192,7 @@
   ///ListBpGraph graph;
   ///ListBpGraph::EdgeMap<int> weight(graph);
-  ///bpGraphReader(graph, std::cin)
-  ///  .edgeMap("weight", weight)
-  ///  .run();
+  ///bpGraphReader(graph, std::cin).
+  ///  edgeMap("weight", weight).
+  ///  run();
   ///\endcode
   ///
Index: lemon/lgf_writer.h
===================================================================
--- lemon/lgf_writer.h	(revision 1161)
+++ lemon/lgf_writer.h	(revision 1092)
@@ -409,13 +409,13 @@
   ///
   ///\code
-  /// DigraphWriter<DGR>(digraph, std::cout)
-  ///   .nodeMap("coordinates", coord_map)
-  ///   .nodeMap("size", size)
-  ///   .nodeMap("title", title)
-  ///   .arcMap("capacity", cap_map)
-  ///   .node("source", src)
-  ///   .node("target", trg)
-  ///   .attribute("caption", caption)
-  ///   .run();
+  /// DigraphWriter<DGR>(digraph, std::cout).
+  ///   nodeMap("coordinates", coord_map).
+  ///   nodeMap("size", size).
+  ///   nodeMap("title", title).
+  ///   arcMap("capacity", cap_map).
+  ///   node("source", src).
+  ///   node("target", trg).
+  ///   attribute("caption", caption).
+  ///   run();
   ///\endcode
   ///
@@ -962,9 +962,9 @@
   ///ListDigraph::Node src, trg;
   ///  // Setting the capacity map and source and target nodes
-  ///digraphWriter(digraph, std::cout)
-  ///  .arcMap("capacity", cap)
-  ///  .node("source", src)
-  ///  .node("target", trg)
-  ///  .run();
+  ///digraphWriter(digraph, std::cout).
+  ///  arcMap("capacity", cap).
+  ///  node("source", src).
+  ///  node("target", trg).
+  ///  run();
   ///\endcode
   ///
@@ -1600,7 +1600,7 @@
   ///ListGraph::EdgeMap<int> weight(graph);
   ///  // Setting the weight map
-  ///graphWriter(graph, std::cout)
-  ///  .edgeMap("weight", weight)
-  ///  .run();
+  ///graphWriter(graph, std::cout).
+  ///  edgeMap("weight", weight).
+  ///  run();
   ///\endcode
   ///
@@ -2420,7 +2420,7 @@
   ///ListBpGraph::EdgeMap<int> weight(graph);
   ///  // Setting the weight map
-  ///bpGraphWriter(graph, std::cout)
-  ///  .edgeMap("weight", weight)
-  ///  .run();
+  ///bpGraphWriter(graph, std::cout).
+  ///  edgeMap("weight", weight).
+  ///  run();
   ///\endcode
   ///
Index: lemon/planarity.h
===================================================================
--- lemon/planarity.h	(revision 1182)
+++ lemon/planarity.h	(revision 1092)
@@ -2384,5 +2384,5 @@
       if (!pe.run()) return false;
 
-      run(pe.embeddingMap());
+      run(pe);
       return true;
     }
@@ -2398,13 +2398,4 @@
     void run(const EmbeddingMap& embedding) {
       typedef SmartEdgeSet<Graph> AuxGraph;
-
-      if (countNodes(_graph) < 3) {
-        int y = 0;
-        for (typename Graph::NodeIt n(_graph); n != INVALID; ++n) {
-          _point_map[n].x = 0;
-          _point_map[n].y = y++;
-        }
-        return;
-      }
 
       if (3 * countNodes(_graph) - 6 == countEdges(_graph)) {
Index: lemon/preflow.h
===================================================================
--- lemon/preflow.h	(revision 1169)
+++ lemon/preflow.h	(revision 1092)
@@ -477,5 +477,5 @@
     /// flow to the given \c flowMap. The \c flowMap should contain a
     /// flow or at least a preflow, i.e. at each node excluding the
-    /// source node the incoming flow should be greater or equal to the
+    /// source node the incoming flow should greater or equal to the
     /// outgoing flow.
     /// \return \c false if the given \c flowMap is not a preflow.
@@ -496,5 +496,5 @@
           excess -= (*_flow)[e];
         }
-        if (_tolerance.negative(excess) && n != _source) return false;
+        if (excess < 0 && n != _source) return false;
         (*_excess)[n] = excess;
       }
@@ -640,5 +640,5 @@
           (*_excess)[n] = excess;
 
-          if (_tolerance.nonZero(excess)) {
+          if (excess != 0) {
             if (new_level + 1 < _level->maxLevel()) {
               _level->liftHighestActive(new_level + 1);
@@ -721,5 +721,5 @@
           (*_excess)[n] = excess;
 
-          if (_tolerance.nonZero(excess)) {
+          if (excess != 0) {
             if (new_level + 1 < _level->maxLevel()) {
               _level->liftActiveOn(level, new_level + 1);
@@ -792,5 +792,5 @@
         if (!reached[n]) {
           _level->dirtyTopButOne(n);
-        } else if (_tolerance.positive((*_excess)[n]) && _target != n) {
+        } else if ((*_excess)[n] > 0 && _target != n) {
           _level->activate(n);
         }
@@ -853,5 +853,5 @@
         (*_excess)[n] = excess;
 
-        if (_tolerance.nonZero(excess)) {
+        if (excess != 0) {
           if (new_level + 1 < _level->maxLevel()) {
             _level->liftHighestActive(new_level + 1);
